
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;
typedef struct _PreferencesPrivate PreferencesPrivate;

#define TYPE_ICON_MENU (icon_menu_get_type ())
#define ICON_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_MENU, IconMenu))
#define ICON_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_MENU, IconMenuClass))
#define IS_ICON_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_MENU))
#define IS_ICON_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_MENU))
#define ICON_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_MENU, IconMenuClass))

typedef struct _IconMenu IconMenu;
typedef struct _IconMenuClass IconMenuClass;
typedef struct _IconMenuPrivate IconMenuPrivate;

struct _Preferences {
	GtkWindow parent_instance;
	PreferencesPrivate * priv;
};

struct _PreferencesClass {
	GtkWindowClass parent_class;
};

struct _PreferencesPrivate {
	GtkColorButton* borderButton;
	GtkColorButton* chargingButton;
	GtkColorButton* drainingButton;
	GtkColorButton* backgroundButton;
	GtkSpinButton* warningPercent;
	GtkSpinButton* criticalPercent;
	GtkEntry* warningCommand;
	GtkEntry* criticalCommand;
};

struct _IconMenu {
	GtkMenu parent_instance;
	IconMenuPrivate * priv;
};

struct _IconMenuClass {
	GtkMenuClass parent_class;
};


static gpointer preferences_parent_class = NULL;
static gpointer icon_menu_parent_class = NULL;

GType preferences_get_type (void);
#define PREFERENCES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREFERENCES, PreferencesPrivate))
enum  {
	PREFERENCES_DUMMY_PROPERTY
};
void preferences_update_app (Preferences* self);
static void _preferences_update_app_gtk_button_clicked (GtkButton* _sender, gpointer self);
void preferences_do_destroy (Preferences* self);
static void _preferences_do_destroy_gtk_button_clicked (GtkButton* _sender, gpointer self);
void preferences_destruct (Preferences* self);
static void _preferences_destruct_gtk_object_destroy (GtkObject* _sender, gpointer self);
Preferences* preferences_new (void);
Preferences* preferences_construct (GType object_type);
Preferences* preferences_new (void);
void preferences_set_colors (Preferences* self, const char* charging, const char* draining, const char* border, const char* background);
void preferences_set_warnings (Preferences* self, const char* wp, const char* wc, const char* cp, const char* cc);
void preferences_display (Preferences* self);
static void preferences_finalize (GObject* obj);
GType icon_menu_get_type (void);
enum  {
	ICON_MENU_DUMMY_PROPERTY
};
static void _lambda0_ (GtkMenuItem* source, IconMenu* self);
static void __lambda0__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _lambda1_ (GtkMenuItem* source, IconMenu* self);
static void __lambda1__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
IconMenu* icon_menu_new (void);
IconMenu* icon_menu_construct (GType object_type);
IconMenu* icon_menu_new (void);


static void g_cclosure_user_marshal_VOID__BOXED_BOXED_BOXED_BOXED_STRING_STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 141 "configurationGUI.vala"
static void _preferences_update_app_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 103 "configurationGUI.vala.c"
	preferences_update_app (self);
}


#line 162 "configurationGUI.vala"
static void _preferences_do_destroy_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 110 "configurationGUI.vala.c"
	preferences_do_destroy (self);
}


#line 166 "configurationGUI.vala"
static void _preferences_destruct_gtk_object_destroy (GtkObject* _sender, gpointer self) {
#line 117 "configurationGUI.vala.c"
	preferences_destruct (self);
}


#line 19 "configurationGUI.vala"
Preferences* preferences_construct (GType object_type) {
#line 124 "configurationGUI.vala.c"
	GParameter * __params;
	GParameter * __params_it;
	Preferences * self;
	GtkVBox* topVbox;
	GtkTable* table;
	GtkFrame* colorsFrame;
	GtkColorButton* _tmp0_;
	GtkColorButton* _tmp1_;
	GtkColorButton* _tmp2_;
	GtkColorButton* _tmp3_;
	GtkAlignment* align;
	GtkLabel* chargingLabel;
	GtkAlignment* _tmp4_;
	GtkLabel* drainingLabel;
	GtkAlignment* _tmp5_;
	GtkLabel* borderLabel;
	GtkAlignment* _tmp6_;
	GtkLabel* backgroundLabel;
	GtkAlignment* _tmp7_;
	GtkFrame* warningFrame;
	GtkTable* _tmp8_;
	GtkLabel* percentLabel;
	GtkSpinButton* _tmp9_;
	GtkAlignment* _tmp10_;
	GtkLabel* commandLabel;
	GtkEntry* _tmp11_;
	GtkFrame* criticalFrame;
	GtkTable* _tmp12_;
	GtkLabel* _tmp13_;
	GtkSpinButton* _tmp14_;
	GtkAlignment* _tmp15_;
	GtkLabel* _tmp16_;
	GtkEntry* _tmp17_;
	GtkHButtonBox* bbox;
	GtkButton* OKButton;
	GtkButton* cancelButton;
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 21 "configurationGUI.vala"
	__params_it->name = "type";
#line 21 "configurationGUI.vala"
	g_value_init (&__params_it->value, GTK_TYPE_WINDOW_TYPE);
#line 21 "configurationGUI.vala"
	g_value_set_enum (&__params_it->value, GTK_WINDOW_TOPLEVEL);
#line 21 "configurationGUI.vala"
	__params_it++;
#line 171 "configurationGUI.vala.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
#line 23 "configurationGUI.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 24 "configurationGUI.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 25 "configurationGUI.vala"
	gtk_window_set_title ((GtkWindow*) self, "Preferences");
#line 26 "configurationGUI.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 181 "configurationGUI.vala.c"
	topVbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 5));
#line 29 "configurationGUI.vala"
	gtk_container_set_border_width ((GtkContainer*) topVbox, (guint) 3);
#line 31 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) topVbox);
#line 187 "configurationGUI.vala.c"
	table = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 4, (guint) 2, FALSE));
#line 33 "configurationGUI.vala"
	gtk_container_set_border_width ((GtkContainer*) table, (guint) 3);
#line 34 "configurationGUI.vala"
	gtk_table_set_col_spacings (table, (guint) 3);
#line 35 "configurationGUI.vala"
	gtk_table_set_row_spacings (table, (guint) 3);
#line 195 "configurationGUI.vala.c"
	colorsFrame = g_object_ref_sink ((GtkFrame*) gtk_frame_new ("Colors"));
#line 37 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) colorsFrame, (GtkWidget*) table);
#line 199 "configurationGUI.vala.c"
	_tmp0_ = NULL;
#line 39 "configurationGUI.vala"
	self->priv->borderButton = (_tmp0_ = g_object_ref_sink ((GtkColorButton*) gtk_color_button_new ()), (self->priv->borderButton == NULL) ? NULL : (self->priv->borderButton = (g_object_unref (self->priv->borderButton), NULL)), _tmp0_);
#line 203 "configurationGUI.vala.c"
	_tmp1_ = NULL;
#line 40 "configurationGUI.vala"
	self->priv->chargingButton = (_tmp1_ = g_object_ref_sink ((GtkColorButton*) gtk_color_button_new ()), (self->priv->chargingButton == NULL) ? NULL : (self->priv->chargingButton = (g_object_unref (self->priv->chargingButton), NULL)), _tmp1_);
#line 207 "configurationGUI.vala.c"
	_tmp2_ = NULL;
#line 41 "configurationGUI.vala"
	self->priv->drainingButton = (_tmp2_ = g_object_ref_sink ((GtkColorButton*) gtk_color_button_new ()), (self->priv->drainingButton == NULL) ? NULL : (self->priv->drainingButton = (g_object_unref (self->priv->drainingButton), NULL)), _tmp2_);
#line 211 "configurationGUI.vala.c"
	_tmp3_ = NULL;
#line 42 "configurationGUI.vala"
	self->priv->backgroundButton = (_tmp3_ = g_object_ref_sink ((GtkColorButton*) gtk_color_button_new ()), (self->priv->backgroundButton == NULL) ? NULL : (self->priv->backgroundButton = (g_object_unref (self->priv->backgroundButton), NULL)), _tmp3_);
#line 215 "configurationGUI.vala.c"
	align = NULL;
	chargingLabel = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Charging:"));
#line 46 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) chargingLabel, (float) 0, (float) 0.5);
#line 48 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) chargingLabel, (guint) 0, (guint) 1, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 222 "configurationGUI.vala.c"
	_tmp4_ = NULL;
#line 49 "configurationGUI.vala"
	align = (_tmp4_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 0, (float) 0)), (align == NULL) ? NULL : (align = (g_object_unref (align), NULL)), _tmp4_);
#line 50 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) self->priv->chargingButton);
#line 51 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) align, (guint) 1, (guint) 2, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 230 "configurationGUI.vala.c"
	drainingLabel = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Draining:"));
#line 54 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) drainingLabel, (float) 0, (float) 0.5);
#line 56 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) drainingLabel, (guint) 0, (guint) 1, (guint) 1, (guint) 2, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 236 "configurationGUI.vala.c"
	_tmp5_ = NULL;
#line 57 "configurationGUI.vala"
	align = (_tmp5_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 0, (float) 0)), (align == NULL) ? NULL : (align = (g_object_unref (align), NULL)), _tmp5_);
#line 58 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) self->priv->drainingButton);
#line 59 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) align, (guint) 1, (guint) 2, (guint) 1, (guint) 2, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 244 "configurationGUI.vala.c"
	borderLabel = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Border:"));
#line 62 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) borderLabel, (float) 0, (float) 0.5);
#line 64 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) borderLabel, (guint) 0, (guint) 1, (guint) 2, (guint) 3, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 250 "configurationGUI.vala.c"
	_tmp6_ = NULL;
#line 65 "configurationGUI.vala"
	align = (_tmp6_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 0, (float) 0)), (align == NULL) ? NULL : (align = (g_object_unref (align), NULL)), _tmp6_);
#line 66 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) self->priv->borderButton);
#line 67 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) align, (guint) 1, (guint) 2, (guint) 2, (guint) 3, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 258 "configurationGUI.vala.c"
	backgroundLabel = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Background:"));
#line 70 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) backgroundLabel, (float) 0, (float) 0.5);
#line 72 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) backgroundLabel, (guint) 0, (guint) 1, (guint) 3, (guint) 4, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 264 "configurationGUI.vala.c"
	_tmp7_ = NULL;
#line 73 "configurationGUI.vala"
	align = (_tmp7_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 0, (float) 0)), (align == NULL) ? NULL : (align = (g_object_unref (align), NULL)), _tmp7_);
#line 74 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) self->priv->backgroundButton);
#line 75 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) align, (guint) 1, (guint) 2, (guint) 3, (guint) 4, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 78 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) topVbox, (GtkWidget*) colorsFrame);
#line 274 "configurationGUI.vala.c"
	warningFrame = g_object_ref_sink ((GtkFrame*) gtk_frame_new ("Warning"));
#line 82 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) topVbox, (GtkWidget*) warningFrame);
#line 278 "configurationGUI.vala.c"
	_tmp8_ = NULL;
#line 83 "configurationGUI.vala"
	table = (_tmp8_ = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 2, (guint) 2, FALSE)), (table == NULL) ? NULL : (table = (g_object_unref (table), NULL)), _tmp8_);
#line 84 "configurationGUI.vala"
	gtk_container_set_border_width ((GtkContainer*) table, (guint) 3);
#line 85 "configurationGUI.vala"
	gtk_table_set_col_spacings (table, (guint) 3);
#line 86 "configurationGUI.vala"
	gtk_table_set_row_spacings (table, (guint) 3);
#line 87 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) warningFrame, (GtkWidget*) table);
#line 290 "configurationGUI.vala.c"
	percentLabel = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Percent:"));
#line 89 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) percentLabel, (float) 0, (float) 0.5);
#line 90 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) percentLabel, (guint) 0, (guint) 1, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 296 "configurationGUI.vala.c"
	_tmp9_ = NULL;
#line 92 "configurationGUI.vala"
	self->priv->warningPercent = (_tmp9_ = g_object_ref_sink ((GtkSpinButton*) gtk_spin_button_new_with_range ((double) 0, (double) 100, (double) 1)), (self->priv->warningPercent == NULL) ? NULL : (self->priv->warningPercent = (g_object_unref (self->priv->warningPercent), NULL)), _tmp9_);
#line 300 "configurationGUI.vala.c"
	_tmp10_ = NULL;
#line 93 "configurationGUI.vala"
	align = (_tmp10_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 0, (float) 0)), (align == NULL) ? NULL : (align = (g_object_unref (align), NULL)), _tmp10_);
#line 94 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) self->priv->warningPercent);
#line 95 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) align, (guint) 1, (guint) 2, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 308 "configurationGUI.vala.c"
	commandLabel = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Command:"));
#line 97 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) commandLabel, (float) 0, (float) 0);
#line 98 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) commandLabel, (guint) 0, (guint) 1, (guint) 1, (guint) 2, GTK_EXPAND, GTK_EXPAND, (guint) 0, (guint) 0);
#line 314 "configurationGUI.vala.c"
	_tmp11_ = NULL;
#line 100 "configurationGUI.vala"
	self->priv->warningCommand = (_tmp11_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), (self->priv->warningCommand == NULL) ? NULL : (self->priv->warningCommand = (g_object_unref (self->priv->warningCommand), NULL)), _tmp11_);
#line 101 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) self->priv->warningCommand, (guint) 1, (guint) 2, (guint) 1, (guint) 2, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 320 "configurationGUI.vala.c"
	criticalFrame = g_object_ref_sink ((GtkFrame*) gtk_frame_new ("Critical"));
#line 105 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) topVbox, (GtkWidget*) criticalFrame);
#line 324 "configurationGUI.vala.c"
	_tmp12_ = NULL;
#line 106 "configurationGUI.vala"
	table = (_tmp12_ = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 2, (guint) 2, FALSE)), (table == NULL) ? NULL : (table = (g_object_unref (table), NULL)), _tmp12_);
#line 107 "configurationGUI.vala"
	gtk_container_set_border_width ((GtkContainer*) table, (guint) 3);
#line 108 "configurationGUI.vala"
	gtk_table_set_col_spacings (table, (guint) 3);
#line 109 "configurationGUI.vala"
	gtk_table_set_row_spacings (table, (guint) 3);
#line 110 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) criticalFrame, (GtkWidget*) table);
#line 336 "configurationGUI.vala.c"
	_tmp13_ = NULL;
#line 111 "configurationGUI.vala"
	percentLabel = (_tmp13_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Percent:")), (percentLabel == NULL) ? NULL : (percentLabel = (g_object_unref (percentLabel), NULL)), _tmp13_);
#line 112 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) percentLabel, (float) 0, (float) 0.5);
#line 113 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) percentLabel, (guint) 0, (guint) 1, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 344 "configurationGUI.vala.c"
	_tmp14_ = NULL;
#line 115 "configurationGUI.vala"
	self->priv->criticalPercent = (_tmp14_ = g_object_ref_sink ((GtkSpinButton*) gtk_spin_button_new_with_range ((double) 0, (double) 100, (double) 1)), (self->priv->criticalPercent == NULL) ? NULL : (self->priv->criticalPercent = (g_object_unref (self->priv->criticalPercent), NULL)), _tmp14_);
#line 348 "configurationGUI.vala.c"
	_tmp15_ = NULL;
#line 116 "configurationGUI.vala"
	align = (_tmp15_ = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0, (float) 0, (float) 0, (float) 0)), (align == NULL) ? NULL : (align = (g_object_unref (align), NULL)), _tmp15_);
#line 117 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) self->priv->criticalPercent);
#line 118 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) align, (guint) 1, (guint) 2, (guint) 0, (guint) 1, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 356 "configurationGUI.vala.c"
	_tmp16_ = NULL;
#line 119 "configurationGUI.vala"
	commandLabel = (_tmp16_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Command:")), (commandLabel == NULL) ? NULL : (commandLabel = (g_object_unref (commandLabel), NULL)), _tmp16_);
#line 120 "configurationGUI.vala"
	gtk_misc_set_alignment ((GtkMisc*) commandLabel, (float) 0, (float) 0);
#line 121 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) commandLabel, (guint) 0, (guint) 1, (guint) 1, (guint) 2, GTK_EXPAND, GTK_EXPAND, (guint) 0, (guint) 0);
#line 364 "configurationGUI.vala.c"
	_tmp17_ = NULL;
#line 123 "configurationGUI.vala"
	self->priv->criticalCommand = (_tmp17_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), (self->priv->criticalCommand == NULL) ? NULL : (self->priv->criticalCommand = (g_object_unref (self->priv->criticalCommand), NULL)), _tmp17_);
#line 124 "configurationGUI.vala"
	gtk_table_attach (table, (GtkWidget*) self->priv->criticalCommand, (guint) 1, (guint) 2, (guint) 1, (guint) 2, GTK_FILL, GTK_FILL, (guint) 0, (guint) 0);
#line 370 "configurationGUI.vala.c"
	bbox = g_object_ref_sink ((GtkHButtonBox*) gtk_hbutton_box_new ());
#line 127 "configurationGUI.vala"
	gtk_button_box_set_layout ((GtkButtonBox*) bbox, GTK_BUTTONBOX_END);
#line 129 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) topVbox, (GtkWidget*) bbox);
#line 376 "configurationGUI.vala.c"
	OKButton = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_OK));
#line 131 "configurationGUI.vala"
	g_signal_connect_object (OKButton, "clicked", (GCallback) _preferences_update_app_gtk_button_clicked, self, 0);
#line 132 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) bbox, (GtkWidget*) OKButton);
#line 382 "configurationGUI.vala.c"
	cancelButton = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_CANCEL));
#line 134 "configurationGUI.vala"
	g_signal_connect_object (cancelButton, "clicked", (GCallback) _preferences_do_destroy_gtk_button_clicked, self, 0);
#line 135 "configurationGUI.vala"
	gtk_container_add ((GtkContainer*) bbox, (GtkWidget*) cancelButton);
#line 137 "configurationGUI.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 5);
#line 138 "configurationGUI.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 139 "configurationGUI.vala"
	g_signal_connect_object ((GtkObject*) self, "destroy", (GCallback) _preferences_destruct_gtk_object_destroy, self, 0);
#line 394 "configurationGUI.vala.c"
	(topVbox == NULL) ? NULL : (topVbox = (g_object_unref (topVbox), NULL));
	(table == NULL) ? NULL : (table = (g_object_unref (table), NULL));
	(colorsFrame == NULL) ? NULL : (colorsFrame = (g_object_unref (colorsFrame), NULL));
	(align == NULL) ? NULL : (align = (g_object_unref (align), NULL));
	(chargingLabel == NULL) ? NULL : (chargingLabel = (g_object_unref (chargingLabel), NULL));
	(drainingLabel == NULL) ? NULL : (drainingLabel = (g_object_unref (drainingLabel), NULL));
	(borderLabel == NULL) ? NULL : (borderLabel = (g_object_unref (borderLabel), NULL));
	(backgroundLabel == NULL) ? NULL : (backgroundLabel = (g_object_unref (backgroundLabel), NULL));
	(warningFrame == NULL) ? NULL : (warningFrame = (g_object_unref (warningFrame), NULL));
	(percentLabel == NULL) ? NULL : (percentLabel = (g_object_unref (percentLabel), NULL));
	(commandLabel == NULL) ? NULL : (commandLabel = (g_object_unref (commandLabel), NULL));
	(criticalFrame == NULL) ? NULL : (criticalFrame = (g_object_unref (criticalFrame), NULL));
	(bbox == NULL) ? NULL : (bbox = (g_object_unref (bbox), NULL));
	(OKButton == NULL) ? NULL : (OKButton = (g_object_unref (OKButton), NULL));
	(cancelButton == NULL) ? NULL : (cancelButton = (g_object_unref (cancelButton), NULL));
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 19 "configurationGUI.vala"
Preferences* preferences_new (void) {
#line 19 "configurationGUI.vala"
	return preferences_construct (TYPE_PREFERENCES);
#line 423 "configurationGUI.vala.c"
}


#line 141 "configurationGUI.vala"
void preferences_update_app (Preferences* self) {
#line 429 "configurationGUI.vala.c"
	GdkColor charging = {0};
	GdkColor draining = {0};
	GdkColor border = {0};
	GdkColor background = {0};
	char* wp;
	const char* _tmp0_;
	char* wc;
	char* cp;
	const char* _tmp1_;
	char* cc;
#line 141 "configurationGUI.vala"
	g_return_if_fail (self != NULL);
#line 442 "configurationGUI.vala.c"
	/*harvest the interface bits and send as a signal
	get the colors*/
#line 146 "configurationGUI.vala"
	gtk_color_button_get_color (self->priv->chargingButton, &charging);
#line 147 "configurationGUI.vala"
	gtk_color_button_get_color (self->priv->drainingButton, &draining);
#line 148 "configurationGUI.vala"
	gtk_color_button_get_color (self->priv->borderButton, &border);
#line 149 "configurationGUI.vala"
	gtk_color_button_get_color (self->priv->backgroundButton, &background);
#line 453 "configurationGUI.vala.c"
	/*get the percents and commands*/
	wp = g_strdup_printf ("%g", gtk_spin_button_get_value (self->priv->warningPercent));
#line 153 "configurationGUI.vala"
	_tmp0_ = NULL;
#line 458 "configurationGUI.vala.c"
	wc = (_tmp0_ = gtk_entry_get_text (self->priv->warningCommand), (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	cp = g_strdup_printf ("%g", gtk_spin_button_get_value (self->priv->criticalPercent));
#line 155 "configurationGUI.vala"
	_tmp1_ = NULL;
#line 463 "configurationGUI.vala.c"
	cc = (_tmp1_ = gtk_entry_get_text (self->priv->criticalCommand), (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_));
	/*emit the signal*/
#line 157 "configurationGUI.vala"
	g_signal_emit_by_name (self, "emit-preferences", &charging, &draining, &border, &background, wp, wc, cp, cc);
#line 468 "configurationGUI.vala.c"
	/*now destroy the interface*/
#line 159 "configurationGUI.vala"
	gtk_object_destroy ((GtkObject*) self);
#line 472 "configurationGUI.vala.c"
	wp = (g_free (wp), NULL);
	wc = (g_free (wc), NULL);
	cp = (g_free (cp), NULL);
	cc = (g_free (cc), NULL);
}


#line 162 "configurationGUI.vala"
void preferences_do_destroy (Preferences* self) {
#line 162 "configurationGUI.vala"
	g_return_if_fail (self != NULL);
#line 164 "configurationGUI.vala"
	gtk_object_destroy ((GtkObject*) self);
#line 486 "configurationGUI.vala.c"
}


#line 166 "configurationGUI.vala"
void preferences_destruct (Preferences* self) {
#line 166 "configurationGUI.vala"
	g_return_if_fail (self != NULL);
#line 168 "configurationGUI.vala"
	g_signal_emit_by_name (self, "destroyed");
#line 496 "configurationGUI.vala.c"
}


#line 170 "configurationGUI.vala"
void preferences_set_colors (Preferences* self, const char* charging, const char* draining, const char* border, const char* background) {
#line 502 "configurationGUI.vala.c"
	GdkColor color = {0};
#line 170 "configurationGUI.vala"
	g_return_if_fail (self != NULL);
#line 170 "configurationGUI.vala"
	g_return_if_fail (charging != NULL);
#line 170 "configurationGUI.vala"
	g_return_if_fail (draining != NULL);
#line 170 "configurationGUI.vala"
	g_return_if_fail (border != NULL);
#line 170 "configurationGUI.vala"
	g_return_if_fail (background != NULL);
#line 514 "configurationGUI.vala.c"
	/*update the button colors*/
#line 174 "configurationGUI.vala"
	gdk_color_parse (charging, &color);
#line 175 "configurationGUI.vala"
	gtk_color_button_set_color (self->priv->chargingButton, &color);
#line 176 "configurationGUI.vala"
	gdk_color_parse (draining, &color);
#line 177 "configurationGUI.vala"
	gtk_color_button_set_color (self->priv->drainingButton, &color);
#line 178 "configurationGUI.vala"
	gdk_color_parse (border, &color);
#line 179 "configurationGUI.vala"
	gtk_color_button_set_color (self->priv->borderButton, &color);
#line 180 "configurationGUI.vala"
	gdk_color_parse (background, &color);
#line 181 "configurationGUI.vala"
	gtk_color_button_set_color (self->priv->backgroundButton, &color);
#line 532 "configurationGUI.vala.c"
}


#line 183 "configurationGUI.vala"
void preferences_set_warnings (Preferences* self, const char* wp, const char* wc, const char* cp, const char* cc) {
#line 183 "configurationGUI.vala"
	g_return_if_fail (self != NULL);
#line 183 "configurationGUI.vala"
	g_return_if_fail (wp != NULL);
#line 183 "configurationGUI.vala"
	g_return_if_fail (wc != NULL);
#line 183 "configurationGUI.vala"
	g_return_if_fail (cp != NULL);
#line 183 "configurationGUI.vala"
	g_return_if_fail (cc != NULL);
#line 185 "configurationGUI.vala"
	gtk_spin_button_set_value (self->priv->warningPercent, (double) atoi (wp));
#line 186 "configurationGUI.vala"
	gtk_spin_button_set_value (self->priv->criticalPercent, (double) atoi (cp));
#line 187 "configurationGUI.vala"
	gtk_entry_set_text (self->priv->warningCommand, wc);
#line 188 "configurationGUI.vala"
	gtk_entry_set_text (self->priv->criticalCommand, cc);
#line 556 "configurationGUI.vala.c"
}


#line 190 "configurationGUI.vala"
void preferences_display (Preferences* self) {
#line 190 "configurationGUI.vala"
	g_return_if_fail (self != NULL);
#line 192 "configurationGUI.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 566 "configurationGUI.vala.c"
}


static void preferences_class_init (PreferencesClass * klass) {
	preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PreferencesPrivate));
	G_OBJECT_CLASS (klass)->finalize = preferences_finalize;
	g_signal_new ("emit_preferences", TYPE_PREFERENCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOXED_BOXED_BOXED_STRING_STRING_STRING_STRING, G_TYPE_NONE, 8, GDK_TYPE_COLOR, GDK_TYPE_COLOR, GDK_TYPE_COLOR, GDK_TYPE_COLOR, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
	g_signal_new ("destroyed", TYPE_PREFERENCES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void preferences_instance_init (Preferences * self) {
	self->priv = PREFERENCES_GET_PRIVATE (self);
}


static void preferences_finalize (GObject* obj) {
	Preferences * self;
	self = PREFERENCES (obj);
	(self->priv->borderButton == NULL) ? NULL : (self->priv->borderButton = (g_object_unref (self->priv->borderButton), NULL));
	(self->priv->chargingButton == NULL) ? NULL : (self->priv->chargingButton = (g_object_unref (self->priv->chargingButton), NULL));
	(self->priv->drainingButton == NULL) ? NULL : (self->priv->drainingButton = (g_object_unref (self->priv->drainingButton), NULL));
	(self->priv->backgroundButton == NULL) ? NULL : (self->priv->backgroundButton = (g_object_unref (self->priv->backgroundButton), NULL));
	(self->priv->warningPercent == NULL) ? NULL : (self->priv->warningPercent = (g_object_unref (self->priv->warningPercent), NULL));
	(self->priv->criticalPercent == NULL) ? NULL : (self->priv->criticalPercent = (g_object_unref (self->priv->criticalPercent), NULL));
	(self->priv->warningCommand == NULL) ? NULL : (self->priv->warningCommand = (g_object_unref (self->priv->warningCommand), NULL));
	(self->priv->criticalCommand == NULL) ? NULL : (self->priv->criticalCommand = (g_object_unref (self->priv->criticalCommand), NULL));
	G_OBJECT_CLASS (preferences_parent_class)->finalize (obj);
}


GType preferences_get_type (void) {
	static GType preferences_type_id = 0;
	if (preferences_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (PreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Preferences), 0, (GInstanceInitFunc) preferences_instance_init, NULL };
		preferences_type_id = g_type_register_static (GTK_TYPE_WINDOW, "Preferences", &g_define_type_info, 0);
	}
	return preferences_type_id;
}


static void _lambda0_ (GtkMenuItem* source, IconMenu* self) {
	g_return_if_fail (source != NULL);
#line 206 "configurationGUI.vala"
	g_signal_emit_by_name (self, "show-preferences");
#line 613 "configurationGUI.vala.c"
}


static void __lambda0__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda0_ (_sender, self);
}


static void _lambda1_ (GtkMenuItem* source, IconMenu* self) {
	g_return_if_fail (source != NULL);
#line 210 "configurationGUI.vala"
	g_signal_emit_by_name (self, "show-about");
#line 626 "configurationGUI.vala.c"
}


static void __lambda1__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	_lambda1_ (_sender, self);
}


#line 202 "configurationGUI.vala"
IconMenu* icon_menu_construct (GType object_type) {
#line 637 "configurationGUI.vala.c"
	IconMenu * self;
	GtkImageMenuItem* menuItem;
	GtkImageMenuItem* _tmp0_;
	self = g_object_newv (object_type, 0, NULL);
	menuItem = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_PREFERENCES, NULL));
#line 206 "configurationGUI.vala"
	g_signal_connect ((GtkMenuItem*) menuItem, "activate", (GCallback) __lambda0__gtk_menu_item_activate, self);
#line 207 "configurationGUI.vala"
	gtk_menu_shell_append ((GtkMenuShell*) self, (GtkWidget*) ((GtkMenuItem*) menuItem));
#line 647 "configurationGUI.vala.c"
	_tmp0_ = NULL;
#line 209 "configurationGUI.vala"
	menuItem = (_tmp0_ = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_ABOUT, NULL)), (menuItem == NULL) ? NULL : (menuItem = (g_object_unref (menuItem), NULL)), _tmp0_);
#line 210 "configurationGUI.vala"
	g_signal_connect ((GtkMenuItem*) menuItem, "activate", (GCallback) __lambda1__gtk_menu_item_activate, self);
#line 211 "configurationGUI.vala"
	gtk_menu_shell_append ((GtkMenuShell*) self, (GtkWidget*) ((GtkMenuItem*) menuItem));
#line 213 "configurationGUI.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 657 "configurationGUI.vala.c"
	(menuItem == NULL) ? NULL : (menuItem = (g_object_unref (menuItem), NULL));
	return self;
}


#line 202 "configurationGUI.vala"
IconMenu* icon_menu_new (void) {
#line 202 "configurationGUI.vala"
	return icon_menu_construct (TYPE_ICON_MENU);
#line 667 "configurationGUI.vala.c"
}


static void icon_menu_class_init (IconMenuClass * klass) {
	icon_menu_parent_class = g_type_class_peek_parent (klass);
	g_signal_new ("show_preferences", TYPE_ICON_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("show_about", TYPE_ICON_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void icon_menu_instance_init (IconMenu * self) {
}


GType icon_menu_get_type (void) {
	static GType icon_menu_type_id = 0;
	if (icon_menu_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (IconMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconMenu), 0, (GInstanceInitFunc) icon_menu_instance_init, NULL };
		icon_menu_type_id = g_type_register_static (GTK_TYPE_MENU, "IconMenu", &g_define_type_info, 0);
	}
	return icon_menu_type_id;
}



static void g_cclosure_user_marshal_VOID__BOXED_BOXED_BOXED_BOXED_STRING_STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED_BOXED_BOXED_BOXED_STRING_STRING_STRING_STRING) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer arg_4, const char* arg_5, const char* arg_6, const char* arg_7, const char* arg_8, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOXED_BOXED_BOXED_STRING_STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 9);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED_BOXED_BOXED_BOXED_STRING_STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_boxed (param_values + 3), g_value_get_boxed (param_values + 4), g_value_get_string (param_values + 5), g_value_get_string (param_values + 6), g_value_get_string (param_values + 7), g_value_get_string (param_values + 8), data2);
}



