/*
vattery

copyright 2009 jezra lickter http://www.jezra.net
modifications by Jemimah Ruhala 

vattery is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

vattery is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with vattery.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_MAIN_CONTROLLER (main_controller_get_type ())
#define MAIN_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_CONTROLLER, main_controller))
#define MAIN_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_CONTROLLER, main_controllerClass))
#define IS_MAIN_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_CONTROLLER))
#define IS_MAIN_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_CONTROLLER))
#define MAIN_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_CONTROLLER, main_controllerClass))

typedef struct _main_controller main_controller;
typedef struct _main_controllerClass main_controllerClass;
typedef struct _main_controllerPrivate main_controllerPrivate;

#define TYPE_ICON_MENU (icon_menu_get_type ())
#define ICON_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_MENU, IconMenu))
#define ICON_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_MENU, IconMenuClass))
#define IS_ICON_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_MENU))
#define IS_ICON_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_MENU))
#define ICON_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_MENU, IconMenuClass))

typedef struct _IconMenu IconMenu;
typedef struct _IconMenuClass IconMenuClass;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;
typedef struct _ParamSpecmain_controller ParamSpecmain_controller;

struct _main_controller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	main_controllerPrivate * priv;
};

struct _main_controllerClass {
	GTypeClass parent_class;
	void (*finalize) (main_controller *self);
};

struct _main_controllerPrivate {
	GRegex* bat_percent_regex;
	GRegex* ac_regex;
	GtkStatusIcon* si;
	char* app_name;
	char* app_version;
	GdkPixbufLoader* pbloader;
	gint bat_percent;
	char* acpitool;
	char* ac_state;
	char* color_draining;
	char* color_charging;
	char* color_background;
	char* color_border;
	char* percent_warning;
	char* percent_critical;
	char* command_warning;
	char* command_critical;
	gboolean displaying_preferences;
	gboolean triggered_warning;
	gboolean triggered_critical;
	IconMenu* iconMenu;
	Configuration* config;
};

typedef enum  {
	CONFIG_ERROR_CREATE_DIR_FAILED,
	CONFIG_ERROR_FILE_NOT_FOUND,
	CONFIG_ERROR_DOCUMENT_EMPTY,
	CONFIG_ERROR_READ_FAILED,
	CONFIG_ERROR_WRITE_FAILED,
	CONFIG_ERROR_NO_KEY_VALUE
} ConfigError;
#define CONFIG_ERROR config_error_quark ()
struct _ParamSpecmain_controller {
	GParamSpec parent_instance;
};


static gpointer main_controller_parent_class = NULL;

gpointer main_controller_ref (gpointer instance);
void main_controller_unref (gpointer instance);
GParamSpec* param_spec_main_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_main_controller (GValue* value, gpointer v_object);
gpointer value_get_main_controller (const GValue* value);
GType main_controller_get_type (void);
GType icon_menu_get_type (void);
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_configuration (GValue* value, gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void);
#define MAIN_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MAIN_CONTROLLER, main_controllerPrivate))
enum  {
	MAIN_CONTROLLER_DUMMY_PROPERTY
};
Configuration* configuration_new (const char* config_file_path);
Configuration* configuration_construct (GType object_type, const char* config_file_path);
char* configuration_get_value (Configuration* self, const char* group, const char* key);
void configuration_set_key_value (Configuration* self, const char* group, const char* key, const char* val);
GQuark config_error_quark (void);
void configuration_save_config (Configuration* self, GError** error);
static void main_controller_status_icon_menu (main_controller* self, guint button, guint time);
static void _lambda2_ (GtkStatusIcon* source, guint button, guint time, main_controller* self);
static void __lambda2__gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self);
IconMenu* icon_menu_new (void);
IconMenu* icon_menu_construct (GType object_type);
static void main_controller_display_about_dialog (main_controller* self);
static void _main_controller_display_about_dialog_icon_menu_show_about (IconMenu* _sender, gpointer self);
static void main_controller_display_preferences_dialog (main_controller* self);
static void _main_controller_display_preferences_dialog_icon_menu_show_preferences (IconMenu* _sender, gpointer self);
static gboolean main_controller_get_battery_status (main_controller* self);
static gboolean _main_controller_get_battery_status_gsource_func (gpointer self);
static main_controller* main_controller_new (const char* name, const char* version);
static main_controller* main_controller_construct (GType object_type, const char* name, const char* version);
static main_controller* main_controller_new (const char* name, const char* version);
static void main_controller_preferences_destroyed (main_controller* self);
Preferences* preferences_new (void);
Preferences* preferences_construct (GType object_type);
GType preferences_get_type (void);
void preferences_set_colors (Preferences* self, const char* charging, const char* draining, const char* border, const char* background);
void preferences_set_warnings (Preferences* self, const char* wp, const char* wc, const char* cp, const char* cc);
static void _main_controller_preferences_destroyed_preferences_destroyed (Preferences* _sender, gpointer self);
static void main_controller_update_and_save_preferences (main_controller* self, const GdkColor* charging, const GdkColor* draining, const GdkColor* border, const GdkColor* background, const char* pw, const char* cw, const char* pc, const char* cc);
static void _lambda3_ (const GdkColor* charge, const GdkColor* drain, const GdkColor* border, const GdkColor* background, const char* wp, const char* wc, const char* cp, const char* cc, main_controller* self);
static void __lambda3__preferences_emit_preferences (Preferences* _sender, const GdkColor* charge, const GdkColor* drain, const GdkColor* border, const GdkColor* background, const char* wp, const char* wc, const char* cp, const char* cc, gpointer self);
void preferences_display (Preferences* self);
static char* main_controller_hex_color (main_controller* self, const GdkColor* c);
static void main_controller_update_status_icon (main_controller* self);
static void main_controller_run (main_controller* self);
static void main_controller_die (main_controller* self, const char* str);
static void main_controller_check_triggers (main_controller* self);
void main_controller_do_command (main_controller* self, const char* raw_command);
static void main_controller_main (char** args, int args_length1);
static void main_controller_finalize (main_controller* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



static void _lambda2_ (GtkStatusIcon* source, guint button, guint time, main_controller* self) {
	g_return_if_fail (source != NULL);
#line 158 "main.vala"
	main_controller_status_icon_menu (self, button, time);
#line 194 "main.vala.c"
}


static void __lambda2__gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self) {
	_lambda2_ (_sender, button, activate_time, self);
}


#line 238 "main.vala"
static void _main_controller_display_about_dialog_icon_menu_show_about (IconMenu* _sender, gpointer self) {
#line 205 "main.vala.c"
	main_controller_display_about_dialog (self);
}


#line 177 "main.vala"
static void _main_controller_display_preferences_dialog_icon_menu_show_preferences (IconMenu* _sender, gpointer self) {
#line 212 "main.vala.c"
	main_controller_display_preferences_dialog (self);
}


#line 331 "main.vala"
static gboolean _main_controller_get_battery_status_gsource_func (gpointer self) {
#line 219 "main.vala.c"
	return main_controller_get_battery_status (self);
}


#line 50 "main.vala"
static main_controller* main_controller_construct (GType object_type, const char* name, const char* version) {
#line 226 "main.vala.c"
	GError * _inner_error_;
	main_controller* self;
	gboolean color_changed;
	gboolean percent_command_changed;
	char* _tmp1_;
	const char* _tmp0_;
	char* _tmp3_;
	const char* _tmp2_;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	char* _tmp11_;
	char* config_file_path;
	Configuration* _tmp12_;
	char* color_charging;
	char* color_draining;
	char* color_background;
	char* color_border;
	char* warn_percent;
	char* warn_command;
	char* crit_percent;
	char* crit_command;
	gboolean _tmp29_;
	GRegex* _tmp30_;
	GRegex* _tmp31_;
	GRegex* _tmp32_;
	GRegex* _tmp33_;
	GtkStatusIcon* _tmp34_;
	IconMenu* _tmp35_;
	GdkPixbufLoader* _tmp36_;
	GdkPixbufLoader* _tmp37_;
#line 50 "main.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 50 "main.vala"
	g_return_val_if_fail (version != NULL, NULL);
#line 266 "main.vala.c"
	_inner_error_ = NULL;
	self = (main_controller*) g_type_create_instance (object_type);
	color_changed = FALSE;
	percent_command_changed = FALSE;
	_tmp1_ = NULL;
#line 54 "main.vala"
	_tmp0_ = NULL;
#line 54 "main.vala"
	self->priv->app_name = (_tmp1_ = (_tmp0_ = name, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->priv->app_name = (g_free (self->priv->app_name), NULL), _tmp1_);
#line 276 "main.vala.c"
	_tmp3_ = NULL;
#line 55 "main.vala"
	_tmp2_ = NULL;
#line 55 "main.vala"
	self->priv->app_version = (_tmp3_ = (_tmp2_ = version, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), self->priv->app_version = (g_free (self->priv->app_version), NULL), _tmp3_);
#line 56 "main.vala"
	self->priv->displaying_preferences = FALSE;
#line 57 "main.vala"
	self->priv->triggered_warning = FALSE;
#line 58 "main.vala"
	self->priv->triggered_critical = FALSE;
#line 288 "main.vala.c"
	/*set default colors*/
	_tmp4_ = NULL;
#line 60 "main.vala"
	self->priv->color_charging = (_tmp4_ = g_strdup ("#0000ff"), self->priv->color_charging = (g_free (self->priv->color_charging), NULL), _tmp4_);
#line 293 "main.vala.c"
	_tmp5_ = NULL;
#line 61 "main.vala"
	self->priv->color_draining = (_tmp5_ = g_strdup ("#ff0000"), self->priv->color_draining = (g_free (self->priv->color_draining), NULL), _tmp5_);
#line 297 "main.vala.c"
	_tmp6_ = NULL;
#line 62 "main.vala"
	self->priv->color_background = (_tmp6_ = g_strdup ("#ffffff"), self->priv->color_background = (g_free (self->priv->color_background), NULL), _tmp6_);
#line 301 "main.vala.c"
	_tmp7_ = NULL;
#line 63 "main.vala"
	self->priv->color_border = (_tmp7_ = g_strdup ("#000000"), self->priv->color_border = (g_free (self->priv->color_border), NULL), _tmp7_);
#line 305 "main.vala.c"
	/*set default percents and commands*/
	_tmp8_ = NULL;
#line 65 "main.vala"
	self->priv->percent_warning = (_tmp8_ = g_strdup ("15"), self->priv->percent_warning = (g_free (self->priv->percent_warning), NULL), _tmp8_);
#line 310 "main.vala.c"
	_tmp9_ = NULL;
#line 66 "main.vala"
	self->priv->percent_critical = (_tmp9_ = g_strdup ("5"), self->priv->percent_critical = (g_free (self->priv->percent_critical), NULL), _tmp9_);
#line 314 "main.vala.c"
	_tmp10_ = NULL;
#line 67 "main.vala"
	self->priv->command_warning = (_tmp10_ = g_strdup ("Xdialog --title 'Battery Alert' --msgbox 'Battery is very low' 0 0"), self->priv->command_warning = (g_free (self->priv->command_warning), NULL), _tmp10_);
#line 318 "main.vala.c"
	_tmp11_ = NULL;
#line 68 "main.vala"
	self->priv->command_critical = (_tmp11_ = g_strdup ("Xdialog --title 'Battery Alert' --msgbox 'Battery is critically low' 0 0"), self->priv->command_critical = (g_free (self->priv->command_critical), NULL), _tmp11_);
#line 322 "main.vala.c"
	/*determine the path of the config file*/
	config_file_path = g_build_filename (g_get_user_config_dir (), name, "config", NULL);
	/*load the config*/
	_tmp12_ = NULL;
#line 72 "main.vala"
	self->priv->config = (_tmp12_ = configuration_new (config_file_path), (self->priv->config == NULL) ? NULL : (self->priv->config = (configuration_unref (self->priv->config), NULL)), _tmp12_);
#line 329 "main.vala.c"
	/*try to load the colors from the config*/
	color_charging = configuration_get_value (self->priv->config, "colors", "charging");
#line 75 "main.vala"
	if (color_charging != NULL) {
#line 334 "main.vala.c"
		char* _tmp14_;
		const char* _tmp13_;
		_tmp14_ = NULL;
#line 77 "main.vala"
		_tmp13_ = NULL;
#line 77 "main.vala"
		self->priv->color_charging = (_tmp14_ = (_tmp13_ = color_charging, (_tmp13_ == NULL) ? NULL : g_strdup (_tmp13_)), self->priv->color_charging = (g_free (self->priv->color_charging), NULL), _tmp14_);
#line 342 "main.vala.c"
	} else {
#line 79 "main.vala"
		configuration_set_key_value (self->priv->config, "colors", "charging", self->priv->color_charging);
#line 80 "main.vala"
		color_changed = TRUE;
#line 348 "main.vala.c"
	}
	color_draining = configuration_get_value (self->priv->config, "colors", "draining");
#line 83 "main.vala"
	if (color_draining != NULL) {
#line 353 "main.vala.c"
		char* _tmp16_;
		const char* _tmp15_;
		_tmp16_ = NULL;
#line 85 "main.vala"
		_tmp15_ = NULL;
#line 85 "main.vala"
		self->priv->color_draining = (_tmp16_ = (_tmp15_ = color_draining, (_tmp15_ == NULL) ? NULL : g_strdup (_tmp15_)), self->priv->color_draining = (g_free (self->priv->color_draining), NULL), _tmp16_);
#line 361 "main.vala.c"
	} else {
#line 88 "main.vala"
		configuration_set_key_value (self->priv->config, "colors", "draining", self->priv->color_draining);
#line 89 "main.vala"
		color_changed = TRUE;
#line 367 "main.vala.c"
	}
	color_background = configuration_get_value (self->priv->config, "colors", "background");
#line 92 "main.vala"
	if (color_background != NULL) {
#line 372 "main.vala.c"
		char* _tmp18_;
		const char* _tmp17_;
		_tmp18_ = NULL;
#line 94 "main.vala"
		_tmp17_ = NULL;
#line 94 "main.vala"
		self->priv->color_background = (_tmp18_ = (_tmp17_ = color_background, (_tmp17_ == NULL) ? NULL : g_strdup (_tmp17_)), self->priv->color_background = (g_free (self->priv->color_background), NULL), _tmp18_);
#line 380 "main.vala.c"
	} else {
#line 97 "main.vala"
		configuration_set_key_value (self->priv->config, "colors", "background", self->priv->color_background);
#line 98 "main.vala"
		color_changed = TRUE;
#line 386 "main.vala.c"
	}
	color_border = configuration_get_value (self->priv->config, "colors", "border");
#line 101 "main.vala"
	if (color_border != NULL) {
#line 391 "main.vala.c"
		char* _tmp20_;
		const char* _tmp19_;
		_tmp20_ = NULL;
#line 103 "main.vala"
		_tmp19_ = NULL;
#line 103 "main.vala"
		self->priv->color_border = (_tmp20_ = (_tmp19_ = color_border, (_tmp19_ == NULL) ? NULL : g_strdup (_tmp19_)), self->priv->color_border = (g_free (self->priv->color_border), NULL), _tmp20_);
#line 399 "main.vala.c"
	} else {
#line 106 "main.vala"
		configuration_set_key_value (self->priv->config, "colors", "border", self->priv->color_border);
#line 107 "main.vala"
		color_changed = TRUE;
#line 405 "main.vala.c"
	}
	warn_percent = configuration_get_value (self->priv->config, "percents", "warning");
#line 110 "main.vala"
	if (warn_percent != NULL) {
#line 410 "main.vala.c"
		char* _tmp22_;
		const char* _tmp21_;
		_tmp22_ = NULL;
#line 112 "main.vala"
		_tmp21_ = NULL;
#line 112 "main.vala"
		self->priv->percent_warning = (_tmp22_ = (_tmp21_ = warn_percent, (_tmp21_ == NULL) ? NULL : g_strdup (_tmp21_)), self->priv->percent_warning = (g_free (self->priv->percent_warning), NULL), _tmp22_);
#line 418 "main.vala.c"
	} else {
#line 115 "main.vala"
		configuration_set_key_value (self->priv->config, "percents", "warning", self->priv->percent_warning);
#line 116 "main.vala"
		percent_command_changed = TRUE;
#line 424 "main.vala.c"
	}
	warn_command = configuration_get_value (self->priv->config, "commands", "warning");
#line 119 "main.vala"
	if (warn_command != NULL) {
#line 429 "main.vala.c"
		char* _tmp24_;
		const char* _tmp23_;
		_tmp24_ = NULL;
#line 121 "main.vala"
		_tmp23_ = NULL;
#line 121 "main.vala"
		self->priv->command_warning = (_tmp24_ = (_tmp23_ = warn_command, (_tmp23_ == NULL) ? NULL : g_strdup (_tmp23_)), self->priv->command_warning = (g_free (self->priv->command_warning), NULL), _tmp24_);
#line 437 "main.vala.c"
	} else {
#line 124 "main.vala"
		configuration_set_key_value (self->priv->config, "commands", "warning", self->priv->command_warning);
#line 125 "main.vala"
		percent_command_changed = TRUE;
#line 443 "main.vala.c"
	}
	crit_percent = configuration_get_value (self->priv->config, "percents", "critical");
#line 128 "main.vala"
	if (crit_percent != NULL) {
#line 448 "main.vala.c"
		char* _tmp26_;
		const char* _tmp25_;
		_tmp26_ = NULL;
#line 130 "main.vala"
		_tmp25_ = NULL;
#line 130 "main.vala"
		self->priv->percent_critical = (_tmp26_ = (_tmp25_ = crit_percent, (_tmp25_ == NULL) ? NULL : g_strdup (_tmp25_)), self->priv->percent_critical = (g_free (self->priv->percent_critical), NULL), _tmp26_);
#line 456 "main.vala.c"
	} else {
#line 133 "main.vala"
		configuration_set_key_value (self->priv->config, "percents", "critical", self->priv->percent_critical);
#line 134 "main.vala"
		percent_command_changed = TRUE;
#line 462 "main.vala.c"
	}
	crit_command = configuration_get_value (self->priv->config, "commands", "critical");
#line 137 "main.vala"
	if (crit_command != NULL) {
#line 467 "main.vala.c"
		char* _tmp28_;
		const char* _tmp27_;
		_tmp28_ = NULL;
#line 139 "main.vala"
		_tmp27_ = NULL;
#line 139 "main.vala"
		self->priv->command_critical = (_tmp28_ = (_tmp27_ = crit_command, (_tmp27_ == NULL) ? NULL : g_strdup (_tmp27_)), self->priv->command_critical = (g_free (self->priv->command_critical), NULL), _tmp28_);
#line 475 "main.vala.c"
	} else {
#line 142 "main.vala"
		configuration_set_key_value (self->priv->config, "commands", "critical", self->priv->command_critical);
#line 143 "main.vala"
		percent_command_changed = TRUE;
#line 481 "main.vala.c"
	}
	_tmp29_ = FALSE;
#line 147 "main.vala"
	if (color_changed) {
#line 147 "main.vala"
		_tmp29_ = TRUE;
#line 488 "main.vala.c"
	} else {
#line 147 "main.vala"
		_tmp29_ = percent_command_changed;
#line 492 "main.vala.c"
	}
	/*if the color has changed, save the configuration*/
#line 147 "main.vala"
	if (_tmp29_) {
#line 149 "main.vala"
		configuration_save_config (self->priv->config, &_inner_error_);
#line 499 "main.vala.c"
		if (_inner_error_ != NULL) {
			config_file_path = (g_free (config_file_path), NULL);
			color_charging = (g_free (color_charging), NULL);
			color_draining = (g_free (color_draining), NULL);
			color_background = (g_free (color_background), NULL);
			color_border = (g_free (color_border), NULL);
			warn_percent = (g_free (warn_percent), NULL);
			warn_command = (g_free (warn_command), NULL);
			crit_percent = (g_free (crit_percent), NULL);
			crit_command = (g_free (crit_command), NULL);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp30_ = g_regex_new (".*, ([0-9]*).*%.*", G_REGEX_CASELESS, G_REGEX_MATCH_NEWLINE_ANY, &_inner_error_);
	if (_inner_error_ != NULL) {
		config_file_path = (g_free (config_file_path), NULL);
		color_charging = (g_free (color_charging), NULL);
		color_draining = (g_free (color_draining), NULL);
		color_background = (g_free (color_background), NULL);
		color_border = (g_free (color_border), NULL);
		warn_percent = (g_free (warn_percent), NULL);
		warn_command = (g_free (warn_command), NULL);
		crit_percent = (g_free (crit_percent), NULL);
		crit_command = (g_free (crit_command), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	/*create a regex to retrieve the current battery power*/
	_tmp31_ = NULL;
#line 152 "main.vala"
	self->priv->bat_percent_regex = (_tmp31_ = _tmp30_, (self->priv->bat_percent_regex == NULL) ? NULL : (self->priv->bat_percent_regex = (g_regex_unref (self->priv->bat_percent_regex), NULL)), _tmp31_);
#line 534 "main.vala.c"
	_tmp32_ = g_regex_new (".*(discharging).*", 0, 0, &_inner_error_);
	if (_inner_error_ != NULL) {
		config_file_path = (g_free (config_file_path), NULL);
		color_charging = (g_free (color_charging), NULL);
		color_draining = (g_free (color_draining), NULL);
		color_background = (g_free (color_background), NULL);
		color_border = (g_free (color_border), NULL);
		warn_percent = (g_free (warn_percent), NULL);
		warn_command = (g_free (warn_command), NULL);
		crit_percent = (g_free (crit_percent), NULL);
		crit_command = (g_free (crit_command), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	/*create a regex to detect the "charging" status*/
	_tmp33_ = NULL;
#line 154 "main.vala"
	self->priv->ac_regex = (_tmp33_ = _tmp32_, (self->priv->ac_regex == NULL) ? NULL : (self->priv->ac_regex = (g_regex_unref (self->priv->ac_regex), NULL)), _tmp33_);
#line 554 "main.vala.c"
	/*create a statusicon*/
	_tmp34_ = NULL;
#line 156 "main.vala"
	self->priv->si = (_tmp34_ = gtk_status_icon_new (), (self->priv->si == NULL) ? NULL : (self->priv->si = (g_object_unref (self->priv->si), NULL)), _tmp34_);
#line 158 "main.vala"
	g_signal_connect (self->priv->si, "popup-menu", (GCallback) __lambda2__gtk_status_icon_popup_menu, self);
#line 561 "main.vala.c"
	/*create the icons menu*/
	_tmp35_ = NULL;
#line 160 "main.vala"
	self->priv->iconMenu = (_tmp35_ = g_object_ref_sink (icon_menu_new ()), (self->priv->iconMenu == NULL) ? NULL : (self->priv->iconMenu = (g_object_unref (self->priv->iconMenu), NULL)), _tmp35_);
#line 566 "main.vala.c"
	/*connect the signals of the icon menu*/
#line 162 "main.vala"
	g_signal_connect (self->priv->iconMenu, "show-about", (GCallback) _main_controller_display_about_dialog_icon_menu_show_about, self);
#line 163 "main.vala"
	g_signal_connect (self->priv->iconMenu, "show-preferences", (GCallback) _main_controller_display_preferences_dialog_icon_menu_show_preferences, self);
#line 572 "main.vala.c"
	_tmp36_ = gdk_pixbuf_loader_new_with_type ("svg", &_inner_error_);
	if (_inner_error_ != NULL) {
		config_file_path = (g_free (config_file_path), NULL);
		color_charging = (g_free (color_charging), NULL);
		color_draining = (g_free (color_draining), NULL);
		color_background = (g_free (color_background), NULL);
		color_border = (g_free (color_border), NULL);
		warn_percent = (g_free (warn_percent), NULL);
		warn_command = (g_free (warn_command), NULL);
		crit_percent = (g_free (crit_percent), NULL);
		crit_command = (g_free (crit_command), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	/*create the pixbufloader*/
	_tmp37_ = NULL;
#line 165 "main.vala"
	self->priv->pbloader = (_tmp37_ = _tmp36_, (self->priv->pbloader == NULL) ? NULL : (self->priv->pbloader = (g_object_unref (self->priv->pbloader), NULL)), _tmp37_);
#line 592 "main.vala.c"
	/*run get_battery_status ever fifteen seconds*/
#line 167 "main.vala"
	g_timeout_add ((guint) 15000, _main_controller_get_battery_status_gsource_func, self);
#line 596 "main.vala.c"
	/*do an initial run of get_battery_status*/
#line 169 "main.vala"
	main_controller_get_battery_status (self);
#line 600 "main.vala.c"
	config_file_path = (g_free (config_file_path), NULL);
	color_charging = (g_free (color_charging), NULL);
	color_draining = (g_free (color_draining), NULL);
	color_background = (g_free (color_background), NULL);
	color_border = (g_free (color_border), NULL);
	warn_percent = (g_free (warn_percent), NULL);
	warn_command = (g_free (warn_command), NULL);
	crit_percent = (g_free (crit_percent), NULL);
	crit_command = (g_free (crit_command), NULL);
	return self;
}


#line 50 "main.vala"
static main_controller* main_controller_new (const char* name, const char* version) {
#line 50 "main.vala"
	return main_controller_construct (TYPE_MAIN_CONTROLLER, name, version);
#line 618 "main.vala.c"
}


#line 171 "main.vala"
static void main_controller_preferences_destroyed (main_controller* self) {
#line 171 "main.vala"
	g_return_if_fail (self != NULL);
#line 626 "main.vala.c"
	/*the preferences dialog has been destroyed*/
#line 174 "main.vala"
	self->priv->displaying_preferences = FALSE;
#line 630 "main.vala.c"
}


#line 171 "main.vala"
static void _main_controller_preferences_destroyed_preferences_destroyed (Preferences* _sender, gpointer self) {
#line 636 "main.vala.c"
	main_controller_preferences_destroyed (self);
}


static void _lambda3_ (const GdkColor* charge, const GdkColor* drain, const GdkColor* border, const GdkColor* background, const char* wp, const char* wc, const char* cp, const char* cc, main_controller* self) {
	g_return_if_fail (wp != NULL);
	g_return_if_fail (wc != NULL);
	g_return_if_fail (cp != NULL);
	g_return_if_fail (cc != NULL);
#line 196 "main.vala"
	main_controller_update_and_save_preferences (self, &(*charge), &(*drain), &(*border), &(*background), wp, wc, cp, cc);
#line 648 "main.vala.c"
}


static void __lambda3__preferences_emit_preferences (Preferences* _sender, const GdkColor* charge, const GdkColor* drain, const GdkColor* border, const GdkColor* background, const char* wp, const char* wc, const char* cp, const char* cc, gpointer self) {
	_lambda3_ (charge, drain, border, background, wp, wc, cp, cc, self);
}


#line 177 "main.vala"
static void main_controller_display_preferences_dialog (main_controller* self) {
#line 177 "main.vala"
	g_return_if_fail (self != NULL);
#line 661 "main.vala.c"
	/*is a display already visible?*/
#line 180 "main.vala"
	if (!self->priv->displaying_preferences) {
#line 665 "main.vala.c"
		Preferences* preferences;
		GdkPixbuf* _tmp0_;
		GdkPixbuf* pb;
		/*create the preferences window*/
		preferences = g_object_ref_sink (preferences_new ());
		/*hey,we are about to show a preferences dialog*/
#line 185 "main.vala"
		self->priv->displaying_preferences = TRUE;
#line 674 "main.vala.c"
		/*update the colors in the preferences*/
#line 187 "main.vala"
		preferences_set_colors (preferences, self->priv->color_charging, self->priv->color_draining, self->priv->color_border, self->priv->color_background);
#line 678 "main.vala.c"
		/*update the warnings of the preferences*/
#line 190 "main.vala"
		preferences_set_warnings (preferences, self->priv->percent_warning, self->priv->command_warning, self->priv->percent_critical, self->priv->command_critical);
#line 682 "main.vala.c"
		/*connect the preferences signals*/
#line 193 "main.vala"
		g_signal_connect (preferences, "destroyed", (GCallback) _main_controller_preferences_destroyed_preferences_destroyed, self);
#line 194 "main.vala"
		g_signal_connect (preferences, "emit-preferences", (GCallback) __lambda3__preferences_emit_preferences, self);
#line 688 "main.vala.c"
		/*set the icon of the preferences window based on the pixbuf of the statusicon*/
#line 199 "main.vala"
		_tmp0_ = NULL;
#line 692 "main.vala.c"
		pb = (_tmp0_ = gtk_status_icon_get_pixbuf (self->priv->si), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 200 "main.vala"
		gtk_window_set_icon ((GtkWindow*) preferences, pb);
#line 696 "main.vala.c"
		/*actually display the thing*/
#line 203 "main.vala"
		preferences_display (preferences);
#line 700 "main.vala.c"
		(preferences == NULL) ? NULL : (preferences = (g_object_unref (preferences), NULL));
		(pb == NULL) ? NULL : (pb = (g_object_unref (pb), NULL));
	}
}


#line 206 "main.vala"
static void main_controller_update_and_save_preferences (main_controller* self, const GdkColor* charging, const GdkColor* draining, const GdkColor* border, const GdkColor* background, const char* pw, const char* cw, const char* pc, const char* cc) {
#line 709 "main.vala.c"
	GError * _inner_error_;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp5_;
	const char* _tmp4_;
	char* _tmp7_;
	const char* _tmp6_;
	char* _tmp9_;
	const char* _tmp8_;
	char* _tmp11_;
	const char* _tmp10_;
#line 206 "main.vala"
	g_return_if_fail (self != NULL);
#line 206 "main.vala"
	g_return_if_fail (pw != NULL);
#line 206 "main.vala"
	g_return_if_fail (cw != NULL);
#line 206 "main.vala"
	g_return_if_fail (pc != NULL);
#line 206 "main.vala"
	g_return_if_fail (cc != NULL);
#line 733 "main.vala.c"
	_inner_error_ = NULL;
	/*start with the colors*/
	_tmp0_ = NULL;
#line 209 "main.vala"
	self->priv->color_charging = (_tmp0_ = main_controller_hex_color (self, &(*charging)), self->priv->color_charging = (g_free (self->priv->color_charging), NULL), _tmp0_);
#line 210 "main.vala"
	configuration_set_key_value (self->priv->config, "colors", "charging", self->priv->color_charging);
#line 741 "main.vala.c"
	_tmp1_ = NULL;
#line 211 "main.vala"
	self->priv->color_draining = (_tmp1_ = main_controller_hex_color (self, &(*draining)), self->priv->color_draining = (g_free (self->priv->color_draining), NULL), _tmp1_);
#line 212 "main.vala"
	configuration_set_key_value (self->priv->config, "colors", "draining", self->priv->color_draining);
#line 747 "main.vala.c"
	_tmp2_ = NULL;
#line 213 "main.vala"
	self->priv->color_border = (_tmp2_ = main_controller_hex_color (self, &(*border)), self->priv->color_border = (g_free (self->priv->color_border), NULL), _tmp2_);
#line 214 "main.vala"
	configuration_set_key_value (self->priv->config, "colors", "border", self->priv->color_border);
#line 753 "main.vala.c"
	_tmp3_ = NULL;
#line 215 "main.vala"
	self->priv->color_background = (_tmp3_ = main_controller_hex_color (self, &(*background)), self->priv->color_background = (g_free (self->priv->color_background), NULL), _tmp3_);
#line 216 "main.vala"
	configuration_set_key_value (self->priv->config, "colors", "background", self->priv->color_background);
#line 759 "main.vala.c"
	/*do the commands and percents*/
	_tmp5_ = NULL;
#line 218 "main.vala"
	_tmp4_ = NULL;
#line 218 "main.vala"
	self->priv->percent_warning = (_tmp5_ = (_tmp4_ = pw, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_)), self->priv->percent_warning = (g_free (self->priv->percent_warning), NULL), _tmp5_);
#line 219 "main.vala"
	configuration_set_key_value (self->priv->config, "percents", "warning", self->priv->percent_warning);
#line 768 "main.vala.c"
	_tmp7_ = NULL;
#line 220 "main.vala"
	_tmp6_ = NULL;
#line 220 "main.vala"
	self->priv->command_warning = (_tmp7_ = (_tmp6_ = cw, (_tmp6_ == NULL) ? NULL : g_strdup (_tmp6_)), self->priv->command_warning = (g_free (self->priv->command_warning), NULL), _tmp7_);
#line 221 "main.vala"
	configuration_set_key_value (self->priv->config, "commands", "warning", self->priv->command_warning);
#line 776 "main.vala.c"
	_tmp9_ = NULL;
#line 223 "main.vala"
	_tmp8_ = NULL;
#line 223 "main.vala"
	self->priv->percent_critical = (_tmp9_ = (_tmp8_ = pc, (_tmp8_ == NULL) ? NULL : g_strdup (_tmp8_)), self->priv->percent_critical = (g_free (self->priv->percent_critical), NULL), _tmp9_);
#line 224 "main.vala"
	configuration_set_key_value (self->priv->config, "percents", "critical", self->priv->percent_critical);
#line 784 "main.vala.c"
	_tmp11_ = NULL;
#line 225 "main.vala"
	_tmp10_ = NULL;
#line 225 "main.vala"
	self->priv->command_critical = (_tmp11_ = (_tmp10_ = cc, (_tmp10_ == NULL) ? NULL : g_strdup (_tmp10_)), self->priv->command_critical = (g_free (self->priv->command_critical), NULL), _tmp11_);
#line 226 "main.vala"
	configuration_set_key_value (self->priv->config, "commands", "critical", self->priv->command_critical);
#line 792 "main.vala.c"
	{
#line 229 "main.vala"
		configuration_save_config (self->priv->config, &_inner_error_);
#line 796 "main.vala.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == CONFIG_ERROR) {
				goto __catch5_config_error;
			}
			goto __finally5;
		}
	}
	goto __finally5;
	__catch5_config_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 232 "main.vala"
			fprintf (stderr, err->message);
#line 813 "main.vala.c"
			(err == NULL) ? NULL : (err = (g_error_free (err), NULL));
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	/*update the icon*/
#line 235 "main.vala"
	main_controller_update_status_icon (self);
#line 826 "main.vala.c"
}


#line 238 "main.vala"
static void main_controller_display_about_dialog (main_controller* self) {
#line 832 "main.vala.c"
	GtkAboutDialog* aboutDialog;
#line 238 "main.vala"
	g_return_if_fail (self != NULL);
#line 836 "main.vala.c"
	/*create an about dialog*/
	aboutDialog = g_object_ref_sink ((GtkAboutDialog*) gtk_about_dialog_new ());
#line 242 "main.vala"
	gtk_about_dialog_set_program_name (aboutDialog, self->priv->app_name);
#line 243 "main.vala"
	gtk_about_dialog_set_version (aboutDialog, self->priv->app_version);
#line 244 "main.vala"
	gtk_about_dialog_set_comments (aboutDialog, "A fairly simple battery monitor.");
#line 245 "main.vala"
	gtk_widget_show_all ((GtkWidget*) aboutDialog);
#line 246 "main.vala"
	gtk_dialog_run ((GtkDialog*) aboutDialog);
#line 247 "main.vala"
	gtk_object_destroy ((GtkObject*) aboutDialog);
#line 851 "main.vala.c"
	(aboutDialog == NULL) ? NULL : (aboutDialog = (g_object_unref (aboutDialog), NULL));
}


#line 249 "main.vala"
static void main_controller_run (main_controller* self) {
#line 249 "main.vala"
	g_return_if_fail (self != NULL);
#line 860 "main.vala.c"
	/*run the Gtk mainloop*/
#line 252 "main.vala"
	gtk_main ();
#line 864 "main.vala.c"
}


#line 254 "main.vala"
static void main_controller_status_icon_menu (main_controller* self, guint button, guint time) {
#line 254 "main.vala"
	g_return_if_fail (self != NULL);
#line 872 "main.vala.c"
	/*popup the iconMenu*/
#line 257 "main.vala"
	gtk_menu_popup ((GtkMenu*) self->priv->iconMenu, NULL, NULL, NULL, NULL, button, (guint32) time);
#line 876 "main.vala.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


#line 259 "main.vala"
static void main_controller_update_status_icon (main_controller* self) {
#line 890 "main.vala.c"
	GError * _inner_error_;
	GdkPixbufLoader* ploader;
	GdkPixbuf* pb;
	char* svg_str;
	char* frect_color;
	double frect_y;
	double frect_height;
	double frect_x;
	double frect_width;
	double brect_x;
	double brect_width;
	gint border_width;
	char* _tmp4_;
	char* _tmp6_;
	char* _tmp5_;
	char* _tmp8_;
	char* _tmp7_;
	char* _tmp10_;
	char* _tmp9_;
	char* _tmp13_;
	guchar* _tmp15_;
	gint svg_data_size;
	gint svg_data_length1;
	gint _tmp14_;
	guchar* svg_data;
#line 259 "main.vala"
	g_return_if_fail (self != NULL);
#line 918 "main.vala.c"
	_inner_error_ = NULL;
	ploader = NULL;
	pb = NULL;
	svg_str = NULL;
	frect_color = NULL;
	frect_y = 0.0;
	frect_height = 0.0;
	frect_x = 0.0;
	frect_width = 0.0;
	brect_x = 0.0;
	brect_width = 0.0;
	border_width = 2;
#line 267 "main.vala"
	brect_width = (double) 50;
#line 268 "main.vala"
	frect_width = brect_width - border_width;
#line 269 "main.vala"
	brect_x = (100 - brect_width) / 2;
#line 270 "main.vala"
	frect_x = (100 - frect_width) / 2;
#line 939 "main.vala.c"
	/*what color should the bar be?*/
#line 272 "main.vala"
	if (_vala_strcmp0 (self->priv->ac_state, "discharging") != 0) {
#line 943 "main.vala.c"
		char* _tmp1_;
		const char* _tmp0_;
		_tmp1_ = NULL;
#line 274 "main.vala"
		_tmp0_ = NULL;
#line 274 "main.vala"
		frect_color = (_tmp1_ = (_tmp0_ = self->priv->color_charging, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), frect_color = (g_free (frect_color), NULL), _tmp1_);
#line 951 "main.vala.c"
	} else {
		char* _tmp3_;
		const char* _tmp2_;
		_tmp3_ = NULL;
#line 277 "main.vala"
		_tmp2_ = NULL;
#line 277 "main.vala"
		frect_color = (_tmp3_ = (_tmp2_ = self->priv->color_draining, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), frect_color = (g_free (frect_color), NULL), _tmp3_);
#line 960 "main.vala.c"
	}
	_tmp4_ = NULL;
#line 280 "main.vala"
	svg_str = (_tmp4_ = g_strdup ("<?xml version=\"1.0\" standalone=\"no\"?>\n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">\n<svg width=\"100px\" height=\"100px\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\">\n"), svg_str = (g_free (svg_str), NULL), _tmp4_);
#line 965 "main.vala.c"
	/*make the border*/
	_tmp6_ = NULL;
#line 812 "glib-2.0.vapi"
	_tmp5_ = NULL;
#line 282 "main.vala"
	svg_str = (_tmp6_ = g_strconcat (svg_str, _tmp5_ = g_strdup_printf ("<rect x=\"%i\" y=\"5\" rx=\"5\" ry=\"5\" width=\"%ipx\" height=\"95px\" fill=\"%s\" stroke=\"%s\" stroke-width=\"%i\"  />\n", (gint) brect_x, (gint) brect_width, self->priv->color_background, self->priv->color_border, border_width), NULL), svg_str = (g_free (svg_str), NULL), _tmp6_);
#line 972 "main.vala.c"
	_tmp5_ = (g_free (_tmp5_), NULL);
	_tmp8_ = NULL;
#line 812 "glib-2.0.vapi"
	_tmp7_ = NULL;
#line 283 "main.vala"
	svg_str = (_tmp8_ = g_strconcat (svg_str, _tmp7_ = g_strdup_printf ("<rect x=\"38\" y=\"0\" width=\"25\" height=\"5px\" fill=\"%s\" stroke=\"%s\" stroke-width=\"%i\"  />\n", self->priv->color_background, self->priv->color_border, border_width), NULL), svg_str = (g_free (svg_str), NULL), _tmp8_);
#line 979 "main.vala.c"
	_tmp7_ = (g_free (_tmp7_), NULL);
	/*make the fill*/
#line 286 "main.vala"
	frect_height = (double) (self->priv->bat_percent - (border_width * 2));
#line 287 "main.vala"
	frect_y = 100 - (frect_height + (border_width / 2));
#line 986 "main.vala.c"
	_tmp10_ = NULL;
#line 812 "glib-2.0.vapi"
	_tmp9_ = NULL;
#line 288 "main.vala"
	svg_str = (_tmp10_ = g_strconcat (svg_str, _tmp9_ = g_strdup_printf ("<rect x=\"%i\" y=\"%i\" rx=\"5\" ry=\"5\" width=\"48px\" height=\"%ipx\" fill=\"%s\" stroke-width=\"0\"  />\n", (gint) frect_x, ((gint) frect_y) + 5, ((gint) frect_height) - 5, frect_color), NULL), svg_str = (g_free (svg_str), NULL), _tmp10_);
#line 992 "main.vala.c"
	_tmp9_ = (g_free (_tmp9_), NULL);
#line 289 "main.vala"
	if (_vala_strcmp0 (self->priv->ac_state, "discharging") != 0) {
#line 996 "main.vala.c"
		char* _tmp12_;
		char* _tmp11_;
		_tmp12_ = NULL;
#line 812 "glib-2.0.vapi"
		_tmp11_ = NULL;
#line 290 "main.vala"
		svg_str = (_tmp12_ = g_strconcat (svg_str, _tmp11_ = g_strdup_printf ("<path fill=\"%s\" stroke=\"%s\" stroke-width=\"1\" d=\"M 50 70 L 60 50 L 50 50 L 50 30 L 40 50 L 50 50 L 50 70 z \"/>", self->priv->color_border, self->priv->color_border), NULL), svg_str = (g_free (svg_str), NULL), _tmp12_);
#line 1004 "main.vala.c"
		_tmp11_ = (g_free (_tmp11_), NULL);
	}
	/*close the svg tag*/
	_tmp13_ = NULL;
#line 292 "main.vala"
	svg_str = (_tmp13_ = g_strconcat (svg_str, "</svg>\n", NULL), svg_str = (g_free (svg_str), NULL), _tmp13_);
#line 1011 "main.vala.c"
	/*convert the str to uchar*/
#line 294 "main.vala"
	_tmp15_ = NULL;
#line 1015 "main.vala.c"
	svg_data = (_tmp15_ = g_new0 (guchar, _tmp14_ = string_get_length (svg_str)), svg_data_length1 = _tmp14_, svg_data_size = svg_data_length1, _tmp15_);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp16_;
			_tmp16_ = TRUE;
#line 295 "main.vala"
			while (TRUE) {
#line 295 "main.vala"
				if (!_tmp16_) {
#line 295 "main.vala"
					i++;
#line 1029 "main.vala.c"
				}
#line 295 "main.vala"
				_tmp16_ = FALSE;
#line 295 "main.vala"
				if (!(i < string_get_length (svg_str))) {
#line 295 "main.vala"
					break;
#line 1037 "main.vala.c"
				}
#line 297 "main.vala"
				svg_data[i] = (guchar) g_utf8_get_char (g_utf8_offset_to_pointer (svg_str, i));
#line 1041 "main.vala.c"
			}
		}
	}
	{
		GdkPixbufLoader* _tmp17_;
		GdkPixbufLoader* _tmp18_;
		GdkPixbuf* _tmp20_;
		GdkPixbuf* _tmp19_;
		char* _tmp21_;
		_tmp17_ = gdk_pixbuf_loader_new_with_type ("svg", &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
			goto __finally6;
		}
		/*create a new pixbufloader*/
		_tmp18_ = NULL;
#line 304 "main.vala"
		ploader = (_tmp18_ = _tmp17_, (ploader == NULL) ? NULL : (ploader = (g_object_unref (ploader), NULL)), _tmp18_);
#line 305 "main.vala"
		gdk_pixbuf_loader_write (ploader, svg_data, svg_data_length1, &_inner_error_);
#line 1062 "main.vala.c"
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
			goto __finally6;
		}
#line 306 "main.vala"
		gdk_pixbuf_loader_close (ploader, &_inner_error_);
#line 1069 "main.vala.c"
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
			goto __finally6;
		}
		_tmp20_ = NULL;
#line 307 "main.vala"
		_tmp19_ = NULL;
#line 307 "main.vala"
		pb = (_tmp20_ = (_tmp19_ = gdk_pixbuf_loader_get_pixbuf (ploader), (_tmp19_ == NULL) ? NULL : g_object_ref (_tmp19_)), (pb == NULL) ? NULL : (pb = (g_object_unref (pb), NULL)), _tmp20_);
#line 308 "main.vala"
		gtk_status_icon_set_from_pixbuf (self->priv->si, pb);
#line 812 "glib-2.0.vapi"
		_tmp21_ = NULL;
#line 309 "main.vala"
		gtk_status_icon_set_tooltip_text (self->priv->si, _tmp21_ = g_strdup_printf ("%s", self->priv->acpitool));
#line 1085 "main.vala.c"
		_tmp21_ = (g_free (_tmp21_), NULL);
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * er;
		er = _inner_error_;
		_inner_error_ = NULL;
		{
#line 312 "main.vala"
			main_controller_die (self, er->message);
#line 1097 "main.vala.c"
			(er == NULL) ? NULL : (er = (g_error_free (er), NULL));
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		(ploader == NULL) ? NULL : (ploader = (g_object_unref (ploader), NULL));
		(pb == NULL) ? NULL : (pb = (g_object_unref (pb), NULL));
		svg_str = (g_free (svg_str), NULL);
		frect_color = (g_free (frect_color), NULL);
		svg_data = (g_free (svg_data), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	(ploader == NULL) ? NULL : (ploader = (g_object_unref (ploader), NULL));
	(pb == NULL) ? NULL : (pb = (g_object_unref (pb), NULL));
	svg_str = (g_free (svg_str), NULL);
	frect_color = (g_free (frect_color), NULL);
	svg_data = (g_free (svg_data), NULL);
}


#line 315 "main.vala"
static void main_controller_die (main_controller* self, const char* str) {
#line 315 "main.vala"
	g_return_if_fail (self != NULL);
#line 315 "main.vala"
	g_return_if_fail (str != NULL);
#line 317 "main.vala"
	fprintf (stdout, "%s v%s: %s\n", self->priv->app_name, self->priv->app_version, str);
#line 318 "main.vala"
	gtk_main_quit ();
#line 1130 "main.vala.c"
}


#line 914 "glib-2.0.vapi"
static char* string_substring (const char* self, glong offset, glong len) {
#line 1136 "main.vala.c"
	char* result;
	glong string_length;
	const char* start;
#line 914 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1142 "main.vala.c"
	string_length = g_utf8_strlen (self, -1);
#line 916 "glib-2.0.vapi"
	if (offset < 0) {
#line 917 "glib-2.0.vapi"
		offset = string_length + offset;
#line 918 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= 0, NULL);
#line 1150 "main.vala.c"
	} else {
#line 920 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1154 "main.vala.c"
	}
#line 922 "glib-2.0.vapi"
	if (len < 0) {
#line 923 "glib-2.0.vapi"
		len = string_length - offset;
#line 1160 "main.vala.c"
	}
#line 925 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1164 "main.vala.c"
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


#line 320 "main.vala"
static char* main_controller_hex_color (main_controller* self, const GdkColor* c) {
#line 1173 "main.vala.c"
	char* result;
	char* ret;
	char* color;
	char* red;
	char* blue;
	char* green;
	char* _tmp2_;
	char* _tmp1_;
	char* _tmp0_;
#line 320 "main.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1185 "main.vala.c"
	ret = g_strdup ("#");
	color = gdk_color_to_string (&(*c));
	red = string_substring (color, (glong) 1, (glong) 2);
	blue = string_substring (color, (glong) 5, (glong) 2);
	green = string_substring (color, (glong) 9, (glong) 2);
	_tmp2_ = NULL;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
#line 328 "main.vala"
	ret = (_tmp2_ = g_strconcat (ret, _tmp1_ = g_strconcat (_tmp0_ = g_strconcat (red, blue, NULL), green, NULL), NULL), ret = (g_free (ret), NULL), _tmp2_);
#line 1196 "main.vala.c"
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp0_ = (g_free (_tmp0_), NULL);
	result = ret;
	color = (g_free (color), NULL);
	red = (g_free (red), NULL);
	blue = (g_free (blue), NULL);
	green = (g_free (green), NULL);
	return result;
}


#line 331 "main.vala"
static gboolean main_controller_get_battery_status (main_controller* self) {
#line 1210 "main.vala.c"
	gboolean result;
	GError * _inner_error_;
	GMatchInfo* match_info;
	char* acpitool;
	char* bat_percent;
	char* ac_state;
	char* _tmp2_;
	gboolean _tmp1_;
	char* _tmp0_;
	gboolean _tmp3_;
	char* _tmp13_;
	const char* _tmp12_;
	char* _tmp15_;
	const char* _tmp14_;
#line 331 "main.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1227 "main.vala.c"
	_inner_error_ = NULL;
	match_info = NULL;
	acpitool = NULL;
	bat_percent = g_strdup ("");
	ac_state = g_strdup ("");
	_tmp2_ = NULL;
	_tmp0_ = NULL;
	_tmp3_ = (_tmp1_ = g_spawn_command_line_sync ("acpitool -b", &_tmp0_, NULL, NULL, &_inner_error_), acpitool = (_tmp2_ = _tmp0_, acpitool = (g_free (acpitool), NULL), _tmp2_), _tmp1_);
	if (_inner_error_ != NULL) {
		(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
		acpitool = (g_free (acpitool), NULL);
		bat_percent = (g_free (bat_percent), NULL);
		ac_state = (g_free (ac_state), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 337 "main.vala"
	if (_tmp3_) {
#line 1247 "main.vala.c"
		GMatchInfo* _tmp6_;
		gboolean _tmp5_;
		GMatchInfo* _tmp4_;
		char* _tmp7_;
		GMatchInfo* _tmp10_;
		gboolean _tmp9_;
		GMatchInfo* _tmp8_;
		char* _tmp11_;
		_tmp6_ = NULL;
		_tmp4_ = NULL;
#line 339 "main.vala"
		_tmp5_ = g_regex_match (self->priv->bat_percent_regex, acpitool, G_REGEX_MATCH_NEWLINE_ANY, &_tmp4_);
#line 339 "main.vala"
		match_info = (_tmp6_ = _tmp4_, (match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL)), _tmp6_);
#line 339 "main.vala"
		_tmp5_;
#line 1264 "main.vala.c"
		_tmp7_ = NULL;
#line 340 "main.vala"
		bat_percent = (_tmp7_ = g_match_info_fetch (match_info, 1), bat_percent = (g_free (bat_percent), NULL), _tmp7_);
#line 1268 "main.vala.c"
		_tmp10_ = NULL;
		_tmp8_ = NULL;
#line 341 "main.vala"
		_tmp9_ = g_regex_match (self->priv->ac_regex, acpitool, G_REGEX_MATCH_NEWLINE_ANY, &_tmp8_);
#line 341 "main.vala"
		match_info = (_tmp10_ = _tmp8_, (match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL)), _tmp10_);
#line 341 "main.vala"
		_tmp9_;
#line 1277 "main.vala.c"
		_tmp11_ = NULL;
#line 342 "main.vala"
		ac_state = (_tmp11_ = g_match_info_fetch (match_info, 1), ac_state = (g_free (ac_state), NULL), _tmp11_);
#line 1281 "main.vala.c"
	} else {
#line 345 "main.vala"
		main_controller_die (self, "can not execute acpitool ");
#line 1285 "main.vala.c"
	}
#line 348 "main.vala"
	self->priv->bat_percent = atoi (bat_percent);
#line 1289 "main.vala.c"
	_tmp13_ = NULL;
#line 349 "main.vala"
	_tmp12_ = NULL;
#line 349 "main.vala"
	self->priv->acpitool = (_tmp13_ = (_tmp12_ = acpitool, (_tmp12_ == NULL) ? NULL : g_strdup (_tmp12_)), self->priv->acpitool = (g_free (self->priv->acpitool), NULL), _tmp13_);
#line 1295 "main.vala.c"
	_tmp15_ = NULL;
#line 350 "main.vala"
	_tmp14_ = NULL;
#line 350 "main.vala"
	self->priv->ac_state = (_tmp15_ = (_tmp14_ = ac_state, (_tmp14_ == NULL) ? NULL : g_strdup (_tmp14_)), self->priv->ac_state = (g_free (self->priv->ac_state), NULL), _tmp15_);
#line 351 "main.vala"
	main_controller_check_triggers (self);
#line 352 "main.vala"
	main_controller_update_status_icon (self);
#line 1305 "main.vala.c"
	/*stdout.printf("%s %s\n", ac_state,bat_percent );*/
	result = TRUE;
	(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
	acpitool = (g_free (acpitool), NULL);
	bat_percent = (g_free (bat_percent), NULL);
	ac_state = (g_free (ac_state), NULL);
	return result;
}


#line 357 "main.vala"
static void main_controller_check_triggers (main_controller* self) {
#line 1318 "main.vala.c"
	gint wp;
	gint cp;
#line 357 "main.vala"
	g_return_if_fail (self != NULL);
#line 1323 "main.vala.c"
	/*get an int of the percents*/
	wp = atoi (self->priv->percent_warning);
	cp = atoi (self->priv->percent_critical);
	/*if we are charging*/
#line 363 "main.vala"
	if (_vala_strcmp0 (self->priv->ac_state, "discharging") != 0) {
#line 365 "main.vala"
		if (self->priv->bat_percent >= wp) {
#line 367 "main.vala"
			self->priv->triggered_warning = FALSE;
#line 1334 "main.vala.c"
		}
#line 369 "main.vala"
		if (self->priv->bat_percent >= cp) {
#line 371 "main.vala"
			self->priv->triggered_critical = FALSE;
#line 1340 "main.vala.c"
		}
	} else {
		gboolean _tmp0_;
		gboolean _tmp1_;
		_tmp0_ = FALSE;
#line 376 "main.vala"
		if (self->priv->bat_percent <= wp) {
#line 376 "main.vala"
			_tmp0_ = self->priv->triggered_warning == FALSE;
#line 1350 "main.vala.c"
		} else {
#line 376 "main.vala"
			_tmp0_ = FALSE;
#line 1354 "main.vala.c"
		}
		/*we are draining
		if the bat percent is below the warning percent and not yet triggered*/
#line 376 "main.vala"
		if (_tmp0_) {
#line 378 "main.vala"
			main_controller_do_command (self, self->priv->command_warning);
#line 379 "main.vala"
			self->priv->triggered_warning = TRUE;
#line 1364 "main.vala.c"
		}
		_tmp1_ = FALSE;
#line 381 "main.vala"
		if (self->priv->bat_percent <= cp) {
#line 381 "main.vala"
			_tmp1_ = self->priv->triggered_critical == FALSE;
#line 1371 "main.vala.c"
		} else {
#line 381 "main.vala"
			_tmp1_ = FALSE;
#line 1375 "main.vala.c"
		}
#line 381 "main.vala"
		if (_tmp1_) {
#line 383 "main.vala"
			main_controller_do_command (self, self->priv->command_critical);
#line 384 "main.vala"
			self->priv->triggered_critical = TRUE;
#line 1383 "main.vala.c"
		}
	}
}


#line 388 "main.vala"
void main_controller_do_command (main_controller* self, const char* raw_command) {
#line 1391 "main.vala.c"
	GError * _inner_error_;
	const char* _tmp0_;
	char* command;
	gboolean _tmp1_;
#line 388 "main.vala"
	g_return_if_fail (self != NULL);
#line 388 "main.vala"
	g_return_if_fail (raw_command != NULL);
#line 1400 "main.vala.c"
	_inner_error_ = NULL;
	/*trim whitespace from the command*/
#line 391 "main.vala"
	_tmp0_ = NULL;
#line 1405 "main.vala.c"
	command = (_tmp0_ = raw_command, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
#line 392 "main.vala"
	g_strstrip (command);
#line 1409 "main.vala.c"
	_tmp1_ = FALSE;
#line 394 "main.vala"
	if (command == NULL) {
#line 394 "main.vala"
		_tmp1_ = TRUE;
#line 1415 "main.vala.c"
	} else {
#line 394 "main.vala"
		_tmp1_ = _vala_strcmp0 (command, "") == 0;
#line 1419 "main.vala.c"
	}
	/*if the command is null or empty, do nothing*/
#line 394 "main.vala"
	if (_tmp1_) {
#line 1424 "main.vala.c"
		command = (g_free (command), NULL);
		return;
	}
	{
#line 401 "main.vala"
		g_spawn_command_line_async (command, &_inner_error_);
#line 1431 "main.vala.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_SPAWN_ERROR) {
				goto __catch7_g_spawn_error;
			}
			goto __finally7;
		}
	}
	goto __finally7;
	__catch7_g_spawn_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 404 "main.vala"
			fprintf (stderr, "%s\n", err->message);
#line 1448 "main.vala.c"
			(err == NULL) ? NULL : (err = (g_error_free (err), NULL));
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		command = (g_free (command), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	command = (g_free (command), NULL);
}


#line 408 "main.vala"
static void main_controller_main (char** args, int args_length1) {
#line 1465 "main.vala.c"
	char* app_name;
	char* app_version;
	main_controller* mc;
	app_name = g_strdup ("vattery-acpitool");
	app_version = g_strdup ("0.7");
	/*init Gtk*/
#line 413 "main.vala"
	gtk_init (&args_length1, &args);
#line 1474 "main.vala.c"
	/*run the main controller*/
	mc = main_controller_new (app_name, app_version);
#line 416 "main.vala"
	main_controller_run (mc);
#line 1479 "main.vala.c"
	app_name = (g_free (app_name), NULL);
	app_version = (g_free (app_version), NULL);
	(mc == NULL) ? NULL : (mc = (main_controller_unref (mc), NULL));
}


#line 408 "main.vala"
int main (int argc, char ** argv) {
#line 408 "main.vala"
	g_type_init ();
#line 408 "main.vala"
	main_controller_main (argv, argc);
#line 408 "main.vala"
	return 0;
#line 1494 "main.vala.c"
}


static void value_main_controller_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_main_controller_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		main_controller_unref (value->data[0].v_pointer);
	}
}


static void value_main_controller_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = main_controller_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_main_controller_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_main_controller_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		main_controller* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = main_controller_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_main_controller_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	main_controller** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = main_controller_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_main_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecmain_controller* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MAIN_CONTROLLER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_main_controller (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MAIN_CONTROLLER), NULL);
	return value->data[0].v_pointer;
}


void value_set_main_controller (GValue* value, gpointer v_object) {
	main_controller* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MAIN_CONTROLLER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MAIN_CONTROLLER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		main_controller_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		main_controller_unref (old);
	}
}


static void main_controller_class_init (main_controllerClass * klass) {
	main_controller_parent_class = g_type_class_peek_parent (klass);
	MAIN_CONTROLLER_CLASS (klass)->finalize = main_controller_finalize;
	g_type_class_add_private (klass, sizeof (main_controllerPrivate));
}


static void main_controller_instance_init (main_controller * self) {
	self->priv = MAIN_CONTROLLER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void main_controller_finalize (main_controller* obj) {
	main_controller * self;
	self = MAIN_CONTROLLER (obj);
	(self->priv->bat_percent_regex == NULL) ? NULL : (self->priv->bat_percent_regex = (g_regex_unref (self->priv->bat_percent_regex), NULL));
	(self->priv->ac_regex == NULL) ? NULL : (self->priv->ac_regex = (g_regex_unref (self->priv->ac_regex), NULL));
	(self->priv->si == NULL) ? NULL : (self->priv->si = (g_object_unref (self->priv->si), NULL));
	self->priv->app_name = (g_free (self->priv->app_name), NULL);
	self->priv->app_version = (g_free (self->priv->app_version), NULL);
	(self->priv->pbloader == NULL) ? NULL : (self->priv->pbloader = (g_object_unref (self->priv->pbloader), NULL));
	self->priv->acpitool = (g_free (self->priv->acpitool), NULL);
	self->priv->ac_state = (g_free (self->priv->ac_state), NULL);
	self->priv->color_draining = (g_free (self->priv->color_draining), NULL);
	self->priv->color_charging = (g_free (self->priv->color_charging), NULL);
	self->priv->color_background = (g_free (self->priv->color_background), NULL);
	self->priv->color_border = (g_free (self->priv->color_border), NULL);
	self->priv->percent_warning = (g_free (self->priv->percent_warning), NULL);
	self->priv->percent_critical = (g_free (self->priv->percent_critical), NULL);
	self->priv->command_warning = (g_free (self->priv->command_warning), NULL);
	self->priv->command_critical = (g_free (self->priv->command_critical), NULL);
	(self->priv->iconMenu == NULL) ? NULL : (self->priv->iconMenu = (g_object_unref (self->priv->iconMenu), NULL));
	(self->priv->config == NULL) ? NULL : (self->priv->config = (configuration_unref (self->priv->config), NULL));
}


GType main_controller_get_type (void) {
	static GType main_controller_type_id = 0;
	if (main_controller_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_main_controller_init, value_main_controller_free_value, value_main_controller_copy_value, value_main_controller_peek_pointer, "p", value_main_controller_collect_value, "p", value_main_controller_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (main_controllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (main_controller), 0, (GInstanceInitFunc) main_controller_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		main_controller_type_id = g_type_register_fundamental (g_type_fundamental_next (), "main_controller", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return main_controller_type_id;
}


gpointer main_controller_ref (gpointer instance) {
	main_controller* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void main_controller_unref (gpointer instance) {
	main_controller* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		MAIN_CONTROLLER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




